# autogenerated by genrb from Log.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Rosgraph_msgs

class Log <::ROS::Message
  def self.md5sum
    "acffd30cd6b6de30f120938c17c593fb"
  end

  def self.type
    "rosgraph_msgs/Log"
  end

  def has_header?
    true
  end

  def message_definition
    "##
## Severity level constants
##
byte DEBUG=1 #debug level
byte INFO=2  #general level
byte WARN=4  #warning level
byte ERROR=8 #error level
byte FATAL=16 #fatal/critical level
##
## Fields
##
Header header
byte level
string name # name of the node
string msg # message 
string file # file the message came from
string function # function the message came from
uint32 line # line the message came from
string[] topics # topic names that the node publishes

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  # Pseudo-constants
  DEBUG = 1
  INFO = 2
  WARN = 4
  ERROR = 8
  FATAL = 16

  attr_accessor :header, :level, :name, :msg, :file, :function, :line, :topics

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','byte','string','string','string','string','uint32','string[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [byte] :level initialize value
  # @option args [string] :name initialize value
  # @option args [string] :msg initialize value
  # @option args [string] :file initialize value
  # @option args [string] :function initialize value
  # @option args [uint32] :line initialize value
  # @option args [string[]] :topics initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:level]
      @level = args[:level]
    else
      @level = 0
    end
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:msg]
      @msg = args[:msg]
    else
      @msg = ''
    end
    if args[:file]
      @file = args[:file]
    else
      @file = ''
    end
    if args[:function]
      @function = args[:function]
    else
      @function = ''
    end
    if args[:line]
      @line = args[:line]
    else
      @line = 0
    end
    if args[:topics]
      @topics = args[:topics]
    else
      @topics = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_c.pack(@level))
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @msg
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @file
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @function
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L.pack(@line))
      length = @topics.length
      buff.write(@@struct_L.pack(length))
      for val1 in @topics
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('c')
      (@level,) = @@struct_c.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @msg = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @file = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @function = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L')
      (@line,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @topics = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @topics.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
