# autogenerated by genrb from UInt16MultiArray.msg. Do not edit.
require 'ros/message'

require "std_msgs/MultiArrayDimension"
require "std_msgs/MultiArrayLayout"

module Std_msgs

class UInt16MultiArray <::ROS::Message
  def self.md5sum
    "52f264f1c973c4b73790d384c6cb4484"
  end

  def self.type
    "std_msgs/UInt16MultiArray"
  end

  def has_header?
    false
  end

  def message_definition
    "# Please look at the MultiArrayLayout message definition for
# documentation on all multiarrays.

MultiArrayLayout  layout        # specification of data layout
uint16[]            data        # array of data


================================================================================
MSG: std_msgs/MultiArrayLayout
# The multiarray declares a generic multi-dimensional array of a
# particular data type.  Dimensions are ordered from outer most
# to inner most.

MultiArrayDimension[] dim # Array of dimension properties
uint32 data_offset        # padding bytes at front of data

# Accessors should ALWAYS be written in terms of dimension stride
# and specified outer-most dimension first.
# 
# multiarray(i,j,k) = data[data_offset + dim_stride[1]*i + dim_stride[2]*j + k]
#
# A standard, 3-channel 640x480 image with interleaved color channels
# would be specified as:
#
# dim[0].label  = \"height\"
# dim[0].size   = 480
# dim[0].stride = 3*640*480 = 921600  (note dim[0] stride is just size of image)
# dim[1].label  = \"width\"
# dim[1].size   = 640
# dim[1].stride = 3*640 = 1920
# dim[2].label  = \"channel\"
# dim[2].size   = 3
# dim[2].stride = 3
#
# multiarray(i,j,k) refers to the ith row, jth column, and kth channel.
================================================================================
MSG: std_msgs/MultiArrayDimension
string label   # label of given dimension
uint32 size    # size of given dimension (in type units)
uint32 stride  # stride of given dimension
"
  end
  attr_accessor :layout, :data

  @@struct_L2 = ::ROS::Struct.new("L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/MultiArrayLayout','uint16[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/MultiArrayLayout] :layout initialize value
  # @option args [uint16[]] :data initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:layout]
      @layout = args[:layout]
    else
      @layout = Std_msgs::MultiArrayLayout.new
    end
    if args[:data]
      @data = args[:data]
    else
      @data = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @layout.dim.length
      buff.write(@@struct_L.pack(length))
      for val1 in @layout.dim
        _x = val1.label
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_L2.pack(_x.size, _x.stride))
      end
      buff.write(@@struct_L.pack(@layout.data_offset))
      length = @data.length
      buff.write(@@struct_L.pack(length))
      pattern = "S#{length}"
      buff.write(*@data.pack(pattern))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @layout == nil
        @layout = Std_msgs::MultiArrayLayout.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @layout.dim = []
      length.times do
        val1 = Std_msgs::MultiArrayDimension.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.label = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.size, _x.stride,) = @@struct_L2.unpack(str[start..(end_point-1)])
        @layout.dim.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L')
      (@layout.data_offset,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "S#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @data = str[start..(end_point-1)].unpack(pattern)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
